from sqlalchemy.orm import Session

import rasax.community.sql_migrations as migrations
from rasax.community.services.role_service import RoleService


def test_permission_migration(session: Session, role_service: RoleService):
    new_permission = "advanced.modify.projects.create"
    roles_to_migrate = ["admin", "annotator"]

    migrations._migrate_new_permission(session, new_permission, roles_to_migrate)

    for role in roles_to_migrate:
        assert new_permission in role_service.get_role_permissions(role)

    other_roles = ["tester"]
    for role in other_roles:
        assert new_permission not in role_service.get_role_permissions(role)
